//Welcome to my new tutorial on Servo motor control with joystick and Arduino by FREAK ENGINEER

#include <Servo.h>   //including the library of the Servo Motor

Servo Xservo;        
Servo Yservo;

int Xpin=A0;        // initialising A0 as the X-axis movement of the joystick
int Ypin=A1;        // initialising A1 as the Y-axis movement of the joystick
int Spin=2;         // initialising digital pin 2 as the joystick's push button
int XSpin=9;        // initialising digital pin 9 as the servo control signal pin
int YSpin=10;       // initialising digital pin 10 as the servo control signal pin
           
// declaring variables for storing read values
int WVx;
int WVy;
int Xval;
int Yval;
int Sval;  

int dt=200;         // intialising delay variable

void setup()
{
  // put your setup code here, to run once:
Serial.begin(9600);

pinMode(Xpin,INPUT);
pinMode(Ypin,INPUT);
pinMode(Spin,INPUT);
pinMode(XSpin,OUTPUT);
pinMode(YSpin,OUTPUT);

Xservo.attach(XSpin);         //enabling pin 9 for Xservo 
Yservo.attach(YSpin);         //enabling pin 10 for Yservo 

digitalWrite(Spin,HIGH);      // intialising the Spin HIGH(1) of the joystick push button
}

void loop()
{
  
 Xval=analogRead(Xpin);       // Reading the value from A0
 WVx=(180./1023.)*Xval;       // Calculating the value for the X axis movement of the joystick
 
 Yval=analogRead(Ypin);       // Reading the value from A1
 WVy=(180./1023.)*Yval;       // Calculating the value for the Y axis movement of the joystick
 
 Sval=digitalRead(Spin);      // Reading the value from digital pin 2

 Xservo.write(WVx);           // Moving the servo using the X-movement of the joystick
 Yservo.write(WVy);           // Moving the servo using the Y-movement of the joystick
 
 delay(dt);
 
 Serial.print("X Value = ");
 Serial.print(Xval);                     // displaying the X-axis value on the serial monitor
 Serial.print(" Y Value = ");
 Serial.print(Yval);                     // displaying the X-axis value on the serial monitor
 Serial.print(" Switch State is ");
 Serial.println(Sval);                   // displaying the push button value on the serial monitor
 
}